%define anolis_release 3
%global _hardened_build 1

Name:          ppp
Version:       2.4.9
Release:       %{anolis_release}%{?dist}
Summary:       The Point-to-Point Protocol daemon
License:       BSD and LGPLv2+ and GPLv2+ and Public Domain
URL:           http://www.samba.org/ppp
Source0:       https://github.com/paulusmack/ppp/archive/ppp-%{version}.tar.gz
Source1:       ppp-pam.conf
Source2:       ppp-logrotate.conf
Source3:       ppp-tmpfiles.conf
Source4:       ip-down
Source5:       ip-down.ipv6to4
Source6:       ip-up
Source7:       ip-up.ipv6to4
Source8:       ipv6-down
Source9:       ipv6-up
Source10:      ifup-ppp
Source11:      ifdown-ppp
Source12:      ppp-watch.tar.xz

Patch0000:     ppp-2.4.9-config.patch
Patch0001:     doc-add-configuration-samples.patch
Patch0002:     ppp-2.4.9-build-sys-don-t-hardcode-LIBDIR-but-set-it-according.patch
Patch0003:     scritps-use-change_resolv_conf-function.patch
Patch0004:     build-sys-don-t-put-connect-errors-log-to-etc-ppp.patch
Patch0005:     ppp-2.4.8-pppd-we-don-t-want-to-accidentally-leak-fds.patch
Patch0006:     ppp-2.4.9-everywhere-O_CLOEXEC-harder.patch
Patch0007:     everywhere-use-SOCK_CLOEXEC-when-creating-socket.patch
Patch0008:     pppd-move-pppd-database-to-var-run-ppp.patch
Patch0009:     rp-pppoe-add-manpage-for-pppoe-discovery.patch
Patch0010:     scritps-fix-ip-up.local-sample.patch
Patch0011:     build-sys-install-rp-pppoe-plugin-files-with-standar.patch
Patch0012:     build-sys-install-pppoatm-plugin-files-with-standard.patch
Patch0013:     ppp-2.4.8-pppd-install-pppd-binary-using-standard-perms-755.patch
Patch0014:     ppp-2.4.9-configure-cflags-allow-commas.patch
Patch0015:     ppp-2.4.9-pppd-eap-Fix-bug-causing-incorrect-response-length-3.patch
Patch0016:     ppp-2.4.9-pppd-Fix-logical-error-in-comparing-valid-encryption.patch
Patch0017:     ppp-2.4.9-pppd-Expose-the-MPPE-keys-generated-through-an-API-2.patch

BuildRequires: gcc make
BuildRequires: pam-devel libpcap-devel systemd systemd-devel openssl-devel glib2-devel

Requires:      glibc >= 2.0.6 /etc/pam.d/system-auth systemd libpcap >= 14:0.8.3-6
Requires(pre): /usr/bin/getent /usr/sbin/groupadd

%description
ppp (Paul's PPP Package) is an open source package which implements
the Point-to-Point Protocol (PPP) on Linux and Solaris systems.

%package -n     network-scripts-%{name}
Summary:        PPP legacy network service support
Requires:       network-scripts
Supplements:    (%{name} and network-scripts)

%description -n network-scripts-%{name}
This package provides the ifup and ifdown scripts for use with the legacy
network service.

%package        devel
Summary:        Headers for ppp plugin development
Requires:       %{name} = %{EVR}

%description    devel
This package provides the header files for building plugins for ppp.

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n %{name}-%{name}-%{version}
tar -xJf %{SOURCE12}

%build
%configure --cflags="$RPM_OPT_FLAGS -fPIC -Wall -fno-strict-aliasing"
%make_build LDFLAGS="%{?build_ldflags} -pie"
%make_build -C ppp-watch LDFLAGS="%{?build_ldflags} -pie"

%install
make INSTROOT=%{buildroot} install install-etcppp
find scripts -type f | xargs chmod a-x
make ROOT=%{buildroot} -C ppp-watch install

mkdir -p %{buildroot}%{_localstatedir}/log/%{name}
mkdir -p %{buildroot}%{_sysconfdir}/pam.d
install -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/pam.d/%{name}
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
install -m 644 -p %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/ppp
mkdir -p %{buildroot}%{_tmpfilesdir}
install -m 644 -p %{SOURCE3} %{buildroot}%{_tmpfilesdir}/ppp.conf

mkdir -p %{buildroot}%{_sysconfdir}/%{name}
install -p %{SOURCE4} %{buildroot}%{_sysconfdir}/%{name}/ip-down
install -p %{SOURCE5} %{buildroot}%{_sysconfdir}/%{name}/ip-down.ipv6to4
install -p %{SOURCE6} %{buildroot}%{_sysconfdir}/%{name}/ip-up
install -p %{SOURCE7} %{buildroot}%{_sysconfdir}/%{name}/ip-up.ipv6to4
install -p %{SOURCE8} %{buildroot}%{_sysconfdir}/%{name}/ipv6-down
install -p %{SOURCE9} %{buildroot}%{_sysconfdir}/%{name}/ipv6-up

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig/network-scripts/
install -p %{SOURCE10} %{buildroot}%{_sysconfdir}/sysconfig/network-scripts/ifup-ppp
install -p %{SOURCE11} %{buildroot}%{_sysconfdir}/sysconfig/network-scripts/ifdown-ppp

mkdir -p %{buildroot}%{_rundir}/%{name}

%generate_compatibility_deps

%pre
/usr/bin/getent group dip >/dev/null 2>&1 || /usr/sbin/groupadd -r -g 40 dip >/dev/null 2>&1 || :

%post
%tmpfiles_create ppp.conf

%files
%dir %{_sysconfdir}/logrotate.d
%config(noreplace) %{_sysconfdir}/ppp/eaptls-client
%config(noreplace) %{_sysconfdir}/ppp/eaptls-server
%config(noreplace) %{_sysconfdir}/ppp/chap-secrets
%config(noreplace) %{_sysconfdir}/ppp/options
%config(noreplace) %{_sysconfdir}/ppp/pap-secrets
%config(noreplace) %{_sysconfdir}/pam.d/ppp
%config(noreplace) %{_sysconfdir}/logrotate.d/ppp
%dir %{_sysconfdir}/ppp
%{_sysconfdir}/ppp/ip-up
%{_sysconfdir}/ppp/ip-down
%{_sysconfdir}/ppp/ip-up.ipv6to4
%{_sysconfdir}/ppp/ip-down.ipv6to4
%{_sysconfdir}/ppp/ipv6-up
%{_sysconfdir}/ppp/ipv6-down
%{_sbindir}/chat
%{_sbindir}/pppd
%{_sbindir}/pppdump
%{_sbindir}/pppoe-discovery
%{_sbindir}/pppstats
%{_sbindir}/ppp-watch
%{_libdir}/pppd
%ghost %dir %{_rundir}/ppp
%attr(700, root, root) %dir %{_localstatedir}/log/ppp
%{_tmpfilesdir}/ppp.conf

%dir %{abidir}
%{abidir}/winbind.dump
%{abidir}/radrealms.dump
%{abidir}/radius.dump
%{abidir}/radattr.dump
%{abidir}/pppol2tp.dump
%{abidir}/pppoe.dump
%{abidir}/pppoe-discovery-option.list
%{abidir}/pppoatm.dump
%{abidir}/pppdump-option.list
%{abidir}/passwordfd.dump
%{abidir}/passprompt.dump
%{abidir}/openl2tp.dump
%{abidir}/minconn.dump
%{_mandir}/man8/chat.8*
%{_mandir}/man8/pppd.8*
%{_mandir}/man8/pppdump.8*
%{_mandir}/man8/pppd-radattr.8*
%{_mandir}/man8/pppd-radius.8*
%{_mandir}/man8/pppstats.8*
%{_mandir}/man8/pppoe-discovery.8*
%{_mandir}/man8/ppp-watch.8*

%files -n network-scripts-%{name}
%{_sysconfdir}/sysconfig/network-scripts/ifdown-ppp
%{_sysconfdir}/sysconfig/network-scripts/ifup-ppp

%files devel
%{_includedir}/pppd
%doc PLUGINS

%files doc
%doc README*
%doc sample scripts FAQ

%changelog
* Fri Apr 14 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 2.4.9-3
- Refactor the specfile

* Wed Mar 08 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 2.4.9-2
- add abi file

* Fri Jul 15 2022 happy_orange <songnannan@linux.alibaba.com> - 2.4.9-1
- Init pacakge from upstream
